com.hazelcast.core

## Interface ITopic<E>

- Type Parameters:
    `E` - the type of the message
  All Superinterfaces:
    DistributedObject
  All Known Implementing Classes:
    ClientReliableTopicProxy, ClientTopicProxy

      public interface ITopic<E>
      extends DistributedObject

  Hazelcast provides distribution mechanism for publishing messages that are delivered to multiple subscribers, which is also known as a publish/subscribe (pub/sub) messaging model. Publish and subscriptions are cluster-wide.

  When a member subscribes for a topic, it is actually registering for messages published by any member in the cluster, including the new members joined after you added the listener.

  Messages are ordered, meaning that listeners(subscribers) will process the messages in the order they are actually published. If cluster member M publishes messages m1, m2, m3...mn to a topic T, then Hazelcast makes sure that all of the subscribers of topic T will receive and process m1, m2, m3...mn in order.

  Since Hazelcast 3.5 it is possible to have reliable topics. Normally all topics rely on the shared eventing system and shared threads. With Hazelcast 3.5 it is possible to configure a topic to be reliable and to get its own `Ringbuffer` to store events and to get its own executor to process events. The events in the ringbuffer are replicated, so they won't get lost when a node goes down.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `addMessageListener(MessageListener<E> listener)` Subscribes to this topic.
    `LocalTopicStats` | `getLocalTopicStats()` Returns statistics about this topic, like total number of publishes/receives.
    `String` | `getName()` Returns the name of this ITopic instance.
    `void` | `publish(E message)` Publishes the message to all subscribers of this topic.
    `boolean` | `removeMessageListener(String registrationId)` Stops receiving messages for the given message listener.

    - ### Methods inherited from interface com.hazelcast.core.DistributedObject

      `destroy, getPartitionKey, getServiceName`

- - ### Method Detail

    - #### getName

          String getName()

      Returns the name of this ITopic instance.
      Specified by:
        `getName` in interface `DistributedObject`
      Returns:
        name of this ITopic instance

    - #### publish

          void publish(E message)

      Publishes the message to all subscribers of this topic.
      Parameters:
        `message` - the message to publish to all subscribers of this topic
      Throws:
        `TopicOverloadException` - if the consumer is too slow (only works in combination with reliable topic)

    - #### addMessageListener

          String addMessageListener(MessageListener<E> listener)

      Subscribes to this topic. When a message is published, the `MessageListener.onMessage(Message)` method of the given MessageListener is called. More than one message listener can be added on one instance.
      Parameters:
        `listener` - the MessageListener to add
      Returns:
        returns the registration ID
      Throws:
        `NullPointerException` - if listener is `null`

    - #### removeMessageListener

          boolean removeMessageListener(String registrationId)

      Stops receiving messages for the given message listener.

      If the given listener already removed, this method does nothing.

      Parameters:
        `registrationId` - ID of listener registration
      Returns:
        `true` if registration is removed, `false` otherwise

    - #### getLocalTopicStats

          LocalTopicStats getLocalTopicStats()

      Returns statistics about this topic, like total number of publishes/receives. The statistics are local to this member and represent the activity on this member, not the entire cluster.
      Returns:
        statistics about this topic

Copyright © 2019. All rights reserved.